import delve.compress;
import delve.stream;
import delve.logging;

import std.file;


int main(string[] args) {
    log_info("starting");

    ulong count;
    {
        scope appender   = new AppendFile("compress_test.data");
        scope compressor = new CompressingWriter(appender);
        scope out_stream = new OutBufferedStream(compressor);

        appender.truncate(0);

        for (uint i = 0; i < 100; ++i) {
            out_stream(i)("the quick brown fox jumped over the lazy dog");
        }
        out_stream.flush();
        count = compressor.flush();

        log_info("wrote %s compressed bytes", count);
    }

    {
        scope reader       = new ReadFile("compress_test.data");
        scope uncompressor = new UnCompressingReader(reader, count);
        scope in_stream    = new InBufferedStream(uncompressor);

        uint expected = 0;
        try {
            for (;;) {
                auto i    = in_stream.get!(int)();
                auto text = in_stream.get!(char[])();

                assert(i == expected);
                assert(text == "the quick brown fox jumped over the lazy dog");

                ++expected;
            }
        }
        catch (EndOfFile ex) {}
        assert(expected == 100);
        log_info("read all the data back again ok");
    }

    remove("compress_test.data");

    log_info("all done");
    return 0;
}
